//======================================================================================================\\
//#######################################   Module information   #######################################\\
//======================================================================================================\\
//                                                                                         
// Company: CERN (BE-BI) 
//                                                        
// File Name: HeartBeat.v  
//
// File versions history:
//
//       DATE          VERSION      AUTHOR             DESCRIPTION
//     - <date>        <version>    <author>           <description>               
//     - 11/11/2015    1.0          M. Barros Marin    First .v module definition
//
// Language: Verilog 2001                                                              
//                                                                                                   
// Targeted device: Vendor Agnostic
//
// Description:
//
//     Module for verifying the presence of a clock.
//                                                                                                  
//======================================================================================================\\
//######################################################################################################\\
//======================================================================================================\\

`timescale 1ns/100ps 

//======================================================================================================\\
//###########################################   Module   ###############################################\\
//======================================================================================================\\

module HeartBeat #(
    
    //==================================  Global parameters  =================================\\    
    
    parameter g_ClkFreq = 32'd80_000_000)(
    
    //========================================================================================\\
    
    //======================================  I/O ports  =====================================\\
    
    //=======\\
    // Reset \\
    //=======\\
  
    input  Reset_ir,
    
    //=======\\
    // Clock \\
    //=======\\
  
    input  Clock_ik,
 
    //============\\
    // Heart beat \\
    //============\\
    
    output HeartBeat_o
    
    //========================================================================================\\
   
);
    
    //====================================  Declarations  ====================================\\
    
    reg [31:0] Timer_c32;
    reg        HeartBeat_q;
    
    //========================================================================================\\
    
    //=====================================  User Logic  =====================================\\
    
    always @(posedge Clock_ik)
        if (Reset_ir) begin
            HeartBeat_q     <=  1'b0;
            Timer_c32       <= 32'b0; 
        end else begin
            if (Timer_c32 == g_ClkFreq-1) begin
                HeartBeat_q <= ~HeartBeat_q;
                Timer_c32   <= 32'b0;
            end else begin
                Timer_c32   <= Timer_c32+1;
            end       
        end
        
    assign HeartBeat_o       = HeartBeat_q;
    
    //========================================================================================\\

endmodule

//======================================================================================================\\
//######################################################################################################\\
//======================================================================================================\\